<html>
<head>
  <title>Blakley Sır Paylaşım Şeması</title>
  <meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
  <meta http-equiv="X-UA-Compatible" content="IE=edge" />
  <meta name="viewport" content="width=device-width, initial-scale=1">

  <script type="text/javascript" src="jquery-1.10.2.js"></script>
  <script type="text/javascript" src="calculationlib/matrixlib.js"></script>
  <script type="text/javascript" src="calculationlib/ecclib.js"></script>
  <script type="text/javascript" src="calculationlib/polynomial.js"></script>
  <script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.6/MathJax.js?config=TeX-AMS-MML_HTMLorMML"></script>
  <!--<script type="text/javascript" src="MathJax/MathJax.js?config=TeX-AMS-MML_HTMLorMML"></script>-->
  <script type="text/x-mathjax-config">
	MathJax.Hub.Config({tex2jax: {inlineMath: [['$','$'], ['\\(','\\)']]}});
    MathJax.Localization.setLocale("tr");
  </script>
  <script>
    var WriteFormula = function(divId, TeX) {
		var selector = "#" + divId;
		var selObj = $(selector)
		if(selObj.length > 0){
			var queue = MathJax.Hub.queue;
			var math = MathJax.Hub.getAllJax(divId)[0];
			queue.Push(
				function () { selObj.css('visibility','hidden') },
				//["resetEquationNumbers",MathJax.InputJax.TeX],
				["Text",math,"\\displaystyle{"+TeX+"}"],
				function () { selObj.css('visibility','visible') }
			);
		}
	}
	var AddFormula = function(container, name, tex) {
		var containerSelector = $('#' + container);
		if ($('#' + name).length == 0)
			containerSelector.append("<div id='" + name + "' style='text-align:center; visibility: visible; padding:10;'>");
		else $('#' + name).html("");

		$('#' + name).append($('<script type="math/tex">').text("\\displaystyle{"+tex+"}"));
		MathJax.Hub.Queue(
			//function () { $('#' + name).css('visibility','hidden')
			["Typeset",MathJax.Hub]
			//,function () { $('#' + name).css('visibility','visible') }
		);
	}
	var CreateInput = function(inputCount, q) {

		var text = "<table>";

		text += "<tr>";
		for (var i = 1; i < inputCount+1; i++)
			text += "<td align='center'>" + i + "</td>";
		text += "</tr>";

		text += "<tr>";
		for (var i = 1; i < inputCount+1; i++)
			text += "<td><input type='text' style='text-align:center;' maxlength='4' size='4' num=" + i + " id='txtInpt" + i + "' /></td>";
		text += "</tr>";

		text += "</table>";
		return text;
	}
	var ReadMatrix = function(text) {
		var data = [];
		text = text.replace( /\s\s+/g, ' ' );
		var lines = text.split(/\r|\n/);
		for (var i = 0; i < lines.length; i++) {
			var lineData = [];
			var cells = lines[i].split(' ');
			for (var j = 0; j < cells.length; j++) {
				if(cells[j] != "") {
					lineData.push(parseInt(cells[j]));
				}
			}
			if (lineData.length > 0)
				data.push(lineData);
		}
		return data;
	}
  </script>
</head>

<body>

  <h2>Blakley Sır Paylaşım Şeması </h2>

  <h3>Sırı Oluşturma</h2>
  <div id="divConstSecretParams">
    <table>
	  <tr>
        <td>  <strong>q</strong>  </td>
        <td>  <input type="text" id="txtQ" value="7"/> <!--$ 1 \lt K \lt N \lt q $--> </td>
      </tr>
      <tr>
        <td>  <strong>K</strong>  </td>
        <td>  <input type="text" id="txtK" value="3"/>  </td>
      </tr>
      <tr>
	    <td>  <strong>N</strong>  </td>
        <td>  <input type="text" id="txtN" value="6"/>  </td>
      </tr>
      <tr>
        <td>  <strong>Sır</strong>  </td>
        <td>  <input type="text" id="txtSecret" value="3"/> $ s \in F_{q} $ </td>
      </tr>
	  <tr>
	    <td> <strong>X</strong> </td>
		<td>  <div id="divXMatrice" />   </td>
	  </tr>
	  <tr>
	    <td> <strong>$A_u$</strong> </td>
		<td>  <div id="divAuMatrice" />   </td>
	  </tr>
      <tr>
        <td> </td>
        <td>  <input type="button" id="btnConstructSecret" value="Sırrı Oluştur" />  </td>
      </tr>
	</table>
  </div>
  <div id="divConstSecretResult"></div>

  <h3>Sırrı Çözme</h3>
  <div id="divFindSecretParams">
    <b>q:</b> <input type='text' id='txtQ2' value='17'/> <br />
    <div id="divSecretInputs"></div>
    <input type='button' id='btnFindSecret' value='Sırrı Bul' />
  </div>
  <div id="divFindSecretResult"></div>


  <script type="text/javascript">
	AuMatrixes = {};

	$(document).ready(function () {
		$("input[type='text']").change(function (e) {
			if (e.target.id == "txtN" || e.target.id == "txtK" || e.target.id == "txtQ"){
				var text = "";
				var N = parseInt($('#txtN').val());
				var K = parseInt($('#txtK').val());
				var q = parseInt($('#txtQ').val());
				var secret = parseInt($('#txtSecret').val()); 
				var generator = new MatrixGenerator(q);
				
				for (var i = 0; i < N; i++) {
					var mat = generator.RandomInt(1, K, 0, q);
					text += "<div id='divAu_"+ i +"'> <input id=txtAu_" + (i+1) + " value='" + mat.ToString2() + "' />  </div>";	
				}
				
				$("#divAuMatrice").html(text);
			}
			if (e.target.id == "txtSecret" || e.target.id == "txtK" || e.target.id == "txtQ") {
				var K = parseInt($('#txtK').val());
				var q = parseInt($('#txtQ').val());
				var secret = parseInt($('#txtSecret').val()); 
				var generator = new MatrixGenerator(q);
				var X = new Matrix(secret).AddRight(generator.RandomInt(1, K-1, 0, q));
				$("#divXMatrice").html("<input id='txtX' value='" + X.ToString2() + "' />");
			}
		});
		$("input[type='button']").click(function (e) {
			if (e.target.id == "btnConstructSecret") {
		
				$("#divConstSecretResult").html("");
				AuMatrixes = {};
				var q = parseInt($('#txtQ').val());
				var K = parseInt($('#txtK').val());
				var N = parseInt($('#txtN').val());
				var secret = parseInt($('#txtSecret').val());
				var generator = new MatrixGenerator(q);
				var processor = new MatrixCalculator(q);

				//var X = new Matrix(secret).AddRight(generator.RandomInt(1, K-1, 0, q));
				var textX = $("#txtX").val();
				var X = new Matrix(ReadMatrix(textX));
				
				// İlk olarak X matrisini sır ilk eleman olacak şekilde oluştruyoruz.
				var textX = "X = " + X.ToLatex();
				AddFormula("divConstSecretResult", "divMat_X", textX);

				for (var i = 1; i <= N; i++) {
					var txtAu = $("#txtAu_" + i).val();
					//var Au = generator.RandomInt(1, K, 0, q);
					Au = new Matrix(ReadMatrix(txtAu));
					AuMatrixes[i] = Au;
					var textAu = "A_{u_{" + i + "}} = " + Au.ToLatex();
					AddFormula("divConstSecretResult", "divMat_Au" + i, textAu);
				}

				var textFormula = "y_u = A_uX^T = \\sum_{i=1}^{t}a_{u,i}x_{i}";
				AddFormula("divConstSecretResult", "divMat_Formula", textFormula);

				for (var i = 1; i <= N; i++) {
					var Au = AuMatrixes[i];
					var yu = processor.Multiply(Au, X.Transpose());
					var textyu = "y_{u_{" + i + "}} = " + Au.ToLatex() +  X.ToLatex() + "^T=" + yu.ToLatex();
					AddFormula("divConstSecretResult", "divMat_yu" + i, textyu);
				}

				$('#txtQ2').val(q);
				$("#divSecretInputs").html(CreateInput(N, q));
				
			}
			else if (e.target.id == "btnFindSecret") {

				var q = parseInt($('#txtQ2').val());
				var generator = new MatrixGenerator(q);
				var processor = new MatrixCalculator(q);

				var indices = [];
				var vectors = [];
				var values = [];
				$("[id^=txtInpt]").each(function() {
					if (!isNaN(parseInt($(this).val()))) {
						var i = parseInt($(this).attr('num'));
						var value =  parseInt($(this).val());
						indices.push(i);
						values.push(value);
						vectors.push(AuMatrixes[i]);
					}
				});

				var t = vectors.length;

				var Mw = vectors[0];
				for (var i = 1; i  < t; i++)
					Mw = Mw.AddBottom(vectors[i]);
				var det = processor.Determinant(Mw);

				var y = new Matrix(values).Transpose();
				var textX = new MatrixGenerator().Pattern(t, 1, function(i,j) { return "x_{" + i + "}"; }).ToLatex();
				var textResult = Mw.ToLatex() + textX + "=" + y.ToLatex();
				AddFormula("divFindSecretResult", "divMat_Result1", textResult);

				var X = processor.Solve(Mw, y);
				var el = processor.Eliminate(Mw, y);
				var textResult = "X=" + X.ToLatex();
				AddFormula("divFindSecretResult", "divMat_Determinant", "Determinant =" + det);
				AddFormula("divFindSecretResult", "divMat_Eliminate", el.ToLatex());
				AddFormula("divFindSecretResult", "divMat_ResultX", textResult);

			}
		});
	
		$("#txtK").change();
	});
	</script>
</body>

</html>
